Commit e321e17f authored by Henry Weller's avatar Henry Weller
Browse files

Reinstated Qt build scripts

Resolves bug-report http://www.openfoam.org/mantisbt/view.php?id=1905
parent 8f0ee0c3
#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011 OpenFOAM Foundation
# \\/ M anipulation |
#------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# etc/relocateQt
#
# Description
# Change prefix when relocating qt installation
#
#------------------------------------------------------------------------------
qtVERSION=4.7.2
#------------------------------------------------------------------------------
# run from third-party directory only
wmakeCheckPwd "$WM_THIRD_PARTY_DIR" || {
echo "Error: Current directory is not \$WM_THIRD_PARTY_DIR"
echo " The environment variables are inconsistent with the installation."
echo " Check the OpenFOAM entries in your dot-files and source them."
exit 1
}
. etc/tools/ThirdPartyFunctions
. etc/tools/QtFunctions
#------------------------------------------------------------------------------
usage() {
exec 1>&2
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<<USAGE
usage: ${0##*/} [OPTION] [VERSION]
options:
-force create qt.conf and edit pkgconfig to use \${prefix}
-help
* adjust relocation prefix for $qtVERSION
USAGE
exit 1
}
unset forceOpt
# parse options
while [ "$#" -gt 0 ]
do
case "$1" in
-h | -help)
usage
;;
-f | -force)
forceOpt=true
shift
;;
[1-9]* | qt-[1-9]*)
qtVERSION="${1%%/}";
qtVERSION="${qtVERSION#qt-}"
shift
;;
*)
usage "unknown option/argument: '$*'"
;;
esac
done
#------------------------------------------------------------------------------
prefixDIR=$installBASE/qt-$qtVERSION
[ "${forceOpt:-false}" = true ] && finalizeQt
changePrefix
# ----------------------------------------------------------------- end-of-file
#---------------------------------*- sh -*-------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011 OpenFOAM Foundation
# \\/ M anipulation |
#------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# File
# etc/tools/QtFunction
#
# Description
# Functions for helping relocate a QT installation
#
#------------------------------------------------------------------------------
#
# create a qt.conf file in the QT bin/
# this can be modified easily if the qt installation gets relocated
#
createQtConf()
{
echo "create:"
echo " $prefixDIR/bin/qt.conf"
[ -n "$prefixDIR" -a -d "$prefixDIR/bin" ] || {
echo "Error: prefixDIR not correctly set"
return
}
echo "[Paths]" > $prefixDIR/bin/qt.conf
echo "Prefix=$prefixDIR" >> $prefixDIR/bin/qt.conf
}
#
# adjust pkgconfig information
# to generalize *location=, -L/... and -I/...
# to use ${prefix}
#
adjustPkgConfig()
{
echo "edit pkgconfig:"
echo " $prefixDIR/lib/pkgconfig/*.pc"
[ -n "$prefixDIR" -a -d "$prefixDIR/lib/pkgconfig" ] || {
echo "Error: prefixDIR not correctly set"
return
}
(
cd $prefixDIR/lib/pkgconfig || exit
unset nfiles
for i in *.pc
do
if [ -f "$i" ]
then
nfiles="x$nfiles"
sed -i \
-e 's@\(location=\)'"$prefixDIR/"'@\1${prefix}/@' \
-e 's@\(-[IL]\)'"$prefixDIR/"'@\1${prefix}/@g' \
$i
fi
done
echo " edited ${#nfiles} files"
)
}
#
# change prefix=... and Prefix=... to use ${prefix}
#
changePrefix()
{
echo "relocate QT installation to new prefix directory:"
echo " $prefixDIR"
echo "edit:"
echo " $prefixDIR/bin/qt.conf"
echo " $prefixDIR/lib/pkgconfig/*.pc"
[ -n "$prefixDIR" -a -d "$prefixDIR/bin" -a -d "$prefixDIR/lib/pkgconfig" ] || {
echo "Error: prefixDIR not correctly set"
return
}
# adjust qt.conf
for i in $prefixDIR/bin/qt.conf
do
if [ -f "$i" ]
then
nfiles="x$nfiles"
sed -i \
-e 's@^\([Pp]refix=\).*$@\1'"$prefixDIR@" \
$i
echo " edited 1 file"
fi
done
# adjust pkgconfig files
(
cd $prefixDIR/lib/pkgconfig || exit
unset nfiles
for i in *.pc
do
if [ -f "$i" ]
then
nfiles="x$nfiles"
sed -i \
-e 's@^\([Pp]refix=\).*$@\1'"$prefixDIR@" \
$i
fi
done
echo " edited ${#nfiles} files"
)
}
# ------------------------------------------------------------------------------
#
# create qt.conf and adjustPkgConfig to use ${prefix} internally
#
finalizeQt()
{
echo "Create/Edit files to ease later relocation of a QT installation"
createQtConf
adjustPkgConfig
}
# ----------------------------------------------------------------- end-of-file
#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011 OpenFOAM Foundation
# \\/ M anipulation |
#------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# makeQt
#
# Description
# Build script for qt-everywhere-opensource-src
#
#------------------------------------------------------------------------------
qtVERSION=4.7.3
qtTYPE=qt-everywhere-opensource-src
#------------------------------------------------------------------------------
# run from third-party directory only
wmakeCheckPwd "$WM_THIRD_PARTY_DIR" || {
echo "Error: Current directory is not \$WM_THIRD_PARTY_DIR"
echo " The environment variables are inconsistent with the installation."
echo " Check the OpenFOAM entries in your dot-files and source them."
exit 1
}
. etc/tools/ThirdPartyFunctions
. etc/tools/QtFunctions
#------------------------------------------------------------------------------
usage() {
exec 1>&2
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<<USAGE
usage: ${0##*/} [OPTION] [VERSION]
options:
-gcc force g++ instead of the value from \$WM_CXX
-help
* build $qtTYPE, version $qtVERSION
USAGE
exit 1
}
# ensure configure gets the correct C++ compiler
[ -n "$WM_CXX" ] && export CXX="$WM_CXX"
# parse options
while [ "$#" -gt 0 ]
do
case "$1" in
-h | -help)
usage
;;
-gcc)
export CXX=g++ # use g++
shift
;;
[1-9]* | qt-[1-9]*)
qtVERSION="${1%%/}";
qtVERSION="${qtVERSION#qt-}"
shift
;;
*)
usage "unknown option/argument: '$*'"
;;
esac
done
#------------------------------------------------------------------------------
qtPACKAGE=$qtTYPE-$qtVERSION
prefixDIR=$installBASE/qt-$qtVERSION
#
# Build QT
#
echo "---------------"
if [ -d "$prefixDIR" -a -r "$prefixDIR/bin/qmake" ]
then
echo "Already built: Qt-$qtVERSION"
else
echo "Starting build: Qt-$qtVERSION"
(
sourceDIR=$WM_THIRD_PARTY_DIR/$qtPACKAGE
buildDIR=$buildBASE/$qtPACKAGE
cd $sourceDIR || exit 1
make distclean 2>/dev/null
rm -rf $buildDIR
mkdir -p $buildDIR
cd $buildDIR
# remove old junk
rm -rf $prefixDIR
# remove any remnants from a previous shadow build
rm -f "$sourceDIR/.qmake.cache" 2>/dev/null
rm -f "$sourceDIR/src/corelib/global/qconfig.h" 2>/dev/null
rm -f "$sourceDIR/src/corelib/global/qconfig.cpp" 2>/dev/null
# compile as opensource, accepting LGPL conditions
echo "yes" | \
$sourceDIR/configure \
--prefix=$prefixDIR \
-opensource \
-nomake demos \
-nomake examples \
&& time make -j $WM_NCOMPPROCS \
&& make install \
&& echo "Built: Qt-$qtVERSION" \
&& finalizeQt
) || {
echo "Error building: Qt-$qtVERSION"
exit 1
}
fi
# ----------------------------------------------------------------- end-of-file
Markdown is supported
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment